
#define _CRT_SECURE_NO_WARNINGS
#define _WINSOCK_DEPRECATED_NO_WARNINGS

#include <stdio.h>
#include <iostream>
#include <TCPModbusIntf.h>

// -------------------------------------------------------------------------

using namespace std;

// -------------------------------------------------------------------------

void testTCPModbusIntf()
{
    WSADATA wsa;
    if (WSAStartup(MAKEWORD(2, 2), &wsa) != 0)
    {
        printf("Failed. Error Code : %d\n", WSAGetLastError());
        exit(EXIT_FAILURE);
    }

    WORD wLocalPort = 7000; // Mobus/TCP Client port

    TCPModbusIntf *tcpModbus = TCPModbusIntf::GetInstance();
    if (tcpModbus == nullptr)
    {
        printf("GetInstance Failed.\n");
        exit(EXIT_FAILURE);
    }

   
    std::string szLocalIpAddr = "192.168.1.200";
    std::string szServerIpAddr = "192.168.1.10";

    bool initDone = tcpModbus->Initialize(0, szLocalIpAddr, wLocalPort, szServerIpAddr);
    if (!initDone)
    {
        printf("Failed.  %s\n", tcpModbus->LastErrorString());
        exit(EXIT_FAILURE);
    }

    WORD wInValue;

    WORD wChannelNo = 3;
    bool isOK = tcpModbus->ReadHoldRegs(wChannelNo, &wInValue, 1);
    if (!isOK)
    {
        printf("ReadHoldRegs Failed.  %s\n", tcpModbus->LastErrorString());
        exit(EXIT_FAILURE);
    }
    double v = (double)wInValue / 65536 * 360;
    cout << "ReadHoldRegs " << wChannelNo << " : " << v << std::endl;

    const int NumOfRegs = 16;
    WORD maxInputRegNum = 16;

    WORD wRInValueIn[NumOfRegs + 8];
    wChannelNo = 0;
    isOK = tcpModbus->ReadInputRegs(wChannelNo, wRInValueIn, maxInputRegNum + 8);
    if (!isOK)
    {
        printf("ReadInputRegs Failed.  %s\n", tcpModbus->LastErrorString());
        exit(EXIT_FAILURE);
    }
    for (int j = 0; j < 24; j++)
    { // 10/17/23
        if (j == 3)
        {                                                   // 11/16/23 was (j < 8)
            auto vI = (double)wRInValueIn[j] / 65536 * 360; // 3/1/23
            printf("ReadInputRegs %d : %8.4f\n", j, vI);    // 11/22/23
        }
        else if (j > 15 && j < 20)
        {                                                          // was (j > 15 && j < 24)
            printf("ReadInputRegs %d: %.4x\n", j, wRInValueIn[j]); // 11/13/23
        }
    }

    tcpModbus->Close();
}

// -------------------------------------------------------------------------

int main(int argc, char **argv)
{
    testTCPModbusIntf();
    ;
    return 0;
}